package com.example.fuzzControll.controller;

import com.example.fuzzControll.pojo.vo.AjaxResult;
import com.example.fuzzControll.service.getServerMessageService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * kitty服务器信息
 */
@RestController
@RequestMapping("/kittyServer")
public class kittyServerMessageController {
    @Autowired
    getServerMessageService getServerMessageService;
    /**
     * 获取服务器stats信息
     */
    @RequestMapping(value = "/stats", method = RequestMethod.GET)
    public AjaxResult getStats( ) {
        try {
            return AjaxResult.success(getServerMessageService.getStats());
        } catch (Exception e) {
            return AjaxResult.error("stats信息获取失败！");
        }
    }
    /**
     * 获取服务器templateInfo信息
     */
    @RequestMapping(value = "/templateInfo", method = RequestMethod.GET)
    public AjaxResult getTemplateInfo( ) {
        try {
            return AjaxResult.success(getServerMessageService.getTemplateInfo());
        } catch (Exception e) {
            return AjaxResult.error("templateInfo信息获取失败！");
        }
    }
    /**
     * 获取服务器stages信息
     */
    @RequestMapping(value = "/stages", method = RequestMethod.GET)
    public AjaxResult getStages( ) {
        try {
            return AjaxResult.success(getServerMessageService.getStages());
        } catch (Exception e) {
            return AjaxResult.error("stats信息获取失败！");
        }
    }
    /**
     * 获取服务器report信息
     */
    @RequestMapping(value = "/report", method = RequestMethod.GET)
    public AjaxResult getReport( ) {
        try {
            return AjaxResult.success(getServerMessageService.getReport());
        } catch (Exception e) {
            return AjaxResult.error("stats信息获取失败！");
        }
    }
}
