package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.conf.kittyProperties;
import com.example.fuzzControll.service.getServerMessageService;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@Service("getServerMessageService")
public class getServerMessageImpl implements getServerMessageService {
    @Autowired
    kittyProperties kitty;

    public String getServerMsg(String messageName) {
        switch (messageName) {
            case "templateInfo": {
                HttpGet httpGetTemplateInfo = new HttpGet(kitty.getTemplateInfoHttp());
                try (CloseableHttpClient httpClient = HttpClients.createDefault();
                     CloseableHttpResponse templateInfoResponse = httpClient.execute(httpGetTemplateInfo);) {
                    return EntityUtils.toString(templateInfoResponse.getEntity(), "utf-8");
                } catch (Exception e) {
                    log.error("templateInfo http error!");
                }
            }
            case "stats": {
                HttpGet httpGetStats = new HttpGet(kitty.getStatsHttp());
                try (CloseableHttpClient httpClient = HttpClients.createDefault();
                     CloseableHttpResponse statsResponse = httpClient.execute(httpGetStats);) {
                    return EntityUtils.toString(statsResponse.getEntity(), "utf-8");
                } catch (Exception e) {
                    log.error("stats http error!");
                }
            }
            case "report": {
                HttpGet httpGetStats = new HttpGet(kitty.getReportHttp());
                try (CloseableHttpClient httpClient = HttpClients.createDefault();
                     CloseableHttpResponse reportResponse = httpClient.execute(httpGetStats);) {
                    return EntityUtils.toString(reportResponse.getEntity(), "utf-8");
                } catch (Exception e) {
                    log.error("report http error!");
                }
            }
            case "stages": {
                HttpGet httpGetStats = new HttpGet(kitty.getStagesHttp());
                try (CloseableHttpClient httpClient = HttpClients.createDefault();
                     CloseableHttpResponse stagesResponse = httpClient.execute(httpGetStats);) {
                    return EntityUtils.toString(stagesResponse.getEntity(), "utf-8");
                } catch (Exception e) {
                    log.error("stages http error!");
                }
            }
            default:
                return "";
        }
    }

    @Override
    public String getStats() {
        return getServerMsg("stats");
    }

    @Override
    public String getTemplateInfo() {
        return getServerMsg("templateInfo");
    }

    @Override
    public String getStages() {
        return getServerMsg("report");
    }

    @Override
    public String getReport() {
        return getServerMsg("stages");
    }
}
